ResourceBar = class( Turbine.UI.Control );
function ResourceBar:Constructor(parent)
    Turbine.UI.Control.Constructor( self )

    self.width = 320
    self.height = 20

    self:SetSize(self.width, self.height)
    self:SetZOrder(100)
    self:SetMouseVisible(false)
    --self:SetBackColor(Turbine.UI.Color(0.125,0.125,0.125))
    self:SetParent(parent)
    self:SetPosition(0, y)

    self.BarDictionary = {}

    self.colourTable = {
        [1] = Turbine.UI.Color(0.8, 0, 0.4, 0),
        [2] = Turbine.UI.Color(0.8, 0, 0.4, 0),
        [3] = Turbine.UI.Color(0.8, 0, 0.4, 0),
        [4] = Turbine.UI.Color(0.8, 0.4, 0.4, 0),
        [5] = Turbine.UI.Color(0.8, 0.4, 0.4, 0),
        [6] = Turbine.UI.Color(0.8, 0.4, 0.4, 0),
        [7] = Turbine.UI.Color(0.8, 0.4, 0, 0),
        [8] = Turbine.UI.Color(0.8, 0.4, 0, 0),
        [9] = Turbine.UI.Color(0.8, 0.4, 0, 0),
    }


    self.colourTable2 = {
        [1] = Turbine.UI.Color(0.8, 0, 0.8, 0),
        [2] = Turbine.UI.Color(0.8, 0, 0.8, 0),
        [3] = Turbine.UI.Color(0.8, 0, 0.8, 0),
        [4] = Turbine.UI.Color(0.8, 0.8, 0.8, 0),
        [5] = Turbine.UI.Color(0.8, 0.8, 0.8, 0),
        [6] = Turbine.UI.Color(0.8, 0.8, 0.8, 0),
        [7] = Turbine.UI.Color(0.8, 0.8, 0, 0),
        [8] = Turbine.UI.Color(0.8, 0.8, 0, 0),
        [9] = Turbine.UI.Color(0.8, 0.8, 0, 0),
    }

    self.boxes = 9

    for i = 1, self.boxes, 1 do
        self.BarDictionary[i] = ResourceBox(self, 3 + (i - 1) * 35 , 30, 20, self.colourTable[i], self.colourTable2[i])
    end  

    self.textBox = Turbine.UI.Label()
    self.textBox:SetParent(self)
    self.textBox:SetSize(20, 20)
    self.textBox:SetPosition((self.width /2 ) - 10 - 3, 0)
    self.textBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.textBox:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
    self.textBox:SetFontStyle( Turbine.UI.FontStyle.Outline )
    self.textBox:SetFont(Turbine.UI.Lotro.Font.TrajanProBold22)
    self.textBox:SetText("0")
    --self.textBox:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self.textBox:SetMouseVisible(false)
end

function ResourceBar:ChangeResource(NewNumber)
    --Turbine.UI.Color(1,0.250,0.250)
    self.textBox:SetText(NewNumber)
    for i = 1, self.boxes, 1 do
        if i <= NewNumber then
            self.BarDictionary[i]:SetVisible(true)
        else
            self.BarDictionary[i]:SetVisible(false)
        end
    end  
end

ResourceBox = class( Turbine.UI.Control );
function ResourceBox:Constructor(parent, x, width, height, colour, colour2)

    Turbine.UI.Control.Constructor( self )
    self:SetParent(parent)
    self:SetBackColor(colour2)
    --self:SetBackground("PrimePlugins/Vitals/Images/FittedSmooth.tga")
    self:SetPosition(x, 0)
    self:SetSize(width, height)
    self:SetMouseVisible(false)

    self.InnerBarBackground = Turbine.UI.Control()
    self.InnerBarBackground:SetParent(self)
    self.InnerBarBackground:SetBackColor(Turbine.UI.Color(0.250,0.250,0.250))
    self.InnerBarBackground:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self.InnerBarBackground:SetPosition(1, 1)
    self.InnerBarBackground:SetSize(width, height - 1)
    self.InnerBarBackground:SetMouseVisible(false)
    self.InnerBarBackground:SetBackColor(colour)

    self.InnerBar = Turbine.UI.Control()
    self.InnerBar:SetParent(self)
    --self.InnerBar:SetBackColor(Turbine.UI.Color(1,0.250,0.250))
    self.InnerBar:SetPosition(1, 1)
    self.InnerBar:SetSize(width - 2, height - 2)
    self.InnerBar:SetMouseVisible(false)

end

function ResourceBox:TurnOn(Colour)
    self.InnerBar:SetBackColor(Colour)
end

function ResourceBox:TurnOff()
    self.InnerBar:SetBackColor()
end