
ClassSkillSlot = class(Turbine.UI.Window)
function ClassSkillSlot:Constructor(parent, x, y, base, normal, skill, hideOnCreation, pet, highlight)
    Turbine.UI.Window.Constructor(self)

    self.base = base
    self.normal = 35
    self.reverse = reverse
    self.normalOpacity = normalOpacity
    self.usageOpacity = usageOpacity
    self.hideOnCreation = hideOnCreation

    self:SetParent(parent)
    self:SetPosition(x, y)
    self:SetSize(self.normal, self.normal)
    self:SetVisible(true)

    if highlight then
        self.highlight = HighlightFrame(self)
    end

    self.baseImageID = 0x41007E35;

    self.currentNumber = -1

    if pet then
        self.typeNumber = 1
    else
        self.typeNumber = 0
    end

    self.IconLabel = Turbine.UI.Lotro.Quickslot()
    self.IconLabel:SetParent(self)
    self.IconLabel:SetSize(self.normal, self.normal)
    --self.IconLabel:SetBackColor(GetRandomColour())
    self.IconLabel:SetPosition(-3, -3)
    self.IconLabel:SetAllowDrop(false)
    self.shortcut = Turbine.UI.Lotro.Shortcut(6 + self.typeNumber, skill)
    self.IconLabel:SetShortcut(self.shortcut)
    if self.hideOnCreation then
        self.IconLabel:SetVisible(false)
        --ChatOutput("X")
    end
    --self.IconLabel:SetVisible(false)

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self)
    self.textLabel:SetSize(self.normal, self.normal)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.textLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetMouseVisible(false)
    self.textLabel:SetPosition(-2, -2)

    --self.fMLabel = ClassSkillLabel(self, 0, 0, base, base, CJIconSmalll, true)

    self.IconLabel.ShortcutChanged = function()
        self.IconLabel:SetShortcut(self.shortcut)
        --ChatOutput(self.IconLabel:GetShortcut():GetData())
    end


    self.duration = 0
    --self.textLabel:SetText("0")
end

function ClassSkillSlot:ToggleVisible(value)
    self:SetVisible(value)
    self.IconLabel:SetVisible(value)
end

function ClassSkillSlot:SetTimer(timer, maxTimer)
    self.duration = timer
end

function ClassSkillSlot:ExecuteUpdate(delta)
    self.duration = self.duration - delta

    local newNumber = math.round(self.duration)
    if newNumber == self.currentNumber then return end

    self.currentNumber = newNumber

    if self.duration < 0 then
        self.textLabel:SetStretchMode(nil)
        self.textLabel:SetStretchMode(1)
        self.textLabel:SetText("")
        return true
    end
    self.textLabel:SetStretchMode(nil)
    self.textLabel:SetStretchMode(1)
    self.textLabel:SetText(self.currentNumber)
    
end

function ClassSkillSlot:Unload()
    self.shortcut = nil
    self.IconLabel:SetParent(nil)
    self.textLabel:SetParent(nil)
    self:SetParent(nil)
    self = nil
end

function ClassSkillSlot:ToggleHighlight(value)
    if self.highlight then
        self.highlight:Toggle(value)
    end
end

function ClassSkillSlot:AddBackground(icon)
    self.IconLabel:SetStretchMode(nil)
    self.IconLabel:SetSize(self.base, self.base)
    self.IconLabel:SetStretchMode(1)
    self.IconLabel:SetBackground(icon)
    self.IconLabel:SetSize(self.normal, self.normal)
end