UpdateHandler = class(Turbine.UI.Control)
function UpdateHandler:Constructor()
    Turbine.UI.Control.Constructor(self);
    self:SetWantsUpdates(true)

    local oldGameTime = Turbine.Engine.GetGameTime()

    self.UpdateDelay = Settings.UpdateDelay

    self.UpdateList = {}

    if self.UpdateDelay > 0 then 
        self.Update = function()
            local currentGameTime = Turbine.Engine.GetGameTime()
            if currentGameTime == oldGameTime then
                return(true)
            end
            local delta = currentGameTime - oldGameTime
    
            if delta < self.UpdateDelay then return end
    
            for key, value in pairs(self.UpdateList) do
                key:ExecuteUpdate(delta)
            end
    
            oldGameTime = currentGameTime
        end
    else
        self.Update = function()
            local currentGameTime = Turbine.Engine.GetGameTime()
            if currentGameTime == oldGameTime then
                return(true)
            end
            local delta = currentGameTime - oldGameTime
    
            for key, value in pairs(self.UpdateList) do
                key:ExecuteUpdate(delta)
            end
    
            oldGameTime = currentGameTime
        end
    end
end

function UpdateHandler:Subscribe(object)
    self.UpdateList[object] = true
end

function UpdateHandler:UnSubscribe(object)
    self.UpdateList[object] = nil
end