SkillCounters = class(Turbine.UI.Window)
function SkillCounters:Constructor()
    self.width = Settings.SNewWidth
    local height = Settings.SNewHeight
    local x = Settings.SX2
    local y = Settings.SY2
    local cooldownTimer = 0
    local oldGameTime = Turbine.Engine.GetGameTime()
    self.Timers = {}
    local ID = 0
    
    self.resort = false
    self.UniqueTimers = {}
    self.count = 0

    self.TimerHeight = Settings.SNewTimer
    --self.font = Settings.SNewFont
    self.font = Turbine.UI.Lotro.Font.VerdanaBold16

    -- Colour scheme [1] outline [2] background [3] bar colour [4] text colour [5] outline colour [6] warning colour
    --Turbine.UI.Color(1,0,0), Turbine.UI.Color(0.5,0,0), Turbine.UI.Color(0,0.125,0.5), Turbine.UI.Color(0,0.6,7), Turbine.UI.Color(0,0.0,0.8)
    self.colourScheme = {Turbine.UI.Color(0,0,0), Turbine.UI.Color(0,0,0), Turbine.UI.Color(0.5,0.5,0.5), Turbine.UI.Color(1,1,1), Turbine.UI.Color(0,0,0), TimerColourNormal2, Settings.BossTimersFrontTexture, Settings.BossTimersBackTexture, Settings.BossTimersFrontOpacity, Settings.BossTimersBackOpacity}

    Turbine.UI.Window.Constructor(self);
    self:SetSize(self.width,height);
    self:SetPosition(x,y);
    self:SetZOrder(1);

    self:SetMouseVisible(false)
    self:SetVisible(true)
    --self:SetWantsUpdates(true)
    --Updater:Subscribe(self)

    self.messageBox = Turbine.UI.Label()
    self.messageBox:SetParent(self)
    self.messageBox:SetSize(self.width,height)
    self.messageBox:SetPosition(0,0)
    self.messageBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.messageBox:SetFont(Settings.SFont)
    self.messageBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.messageBox:SetMouseVisible(false)
    self.messageBox:SetVisible(false)
  
    local moveBox = MoveBox(self, self.width, height, "Boss CDs")
    
    self.ToggleMove = function()
        moveBox:ToggleMove()
    end

    self.ResortList = function()
        local counter = 0
        for _,v in spairs(self.Timers, function(t,a,b) return t[b][2] > t[a][2] end) do
            v[1]:SetPosition(0, counter * self.TimerHeight) 
            counter = counter + 1
        end

        self.resort = false
    end
end

function SkillCounters:ExecuteUpdate(delta)    
    --We had an update
    for key, value in pairs(self.Timers) do 
        --ChatOutput(value[2])
        value[2] = value[2] - delta
        value[1]:UpdateText(delta)
        if value[2] < 0 then 
            if value[5] then
                value[1]:ChangeDuration(value[4])
                value[2] = value[4]
                if Fight and Fight:FightStatus() then value[1]:ChangeDuration(value[4]) end
            else
                self.UniqueTimers[value[3]] = nil
                value[1]:Destroy()
                self.Timers[key] = nil
                self.resort = true
                self.count = self.count - 1
            end
        end
        --value[1]:SetText(value[3].." "..value[2])
    end

    if self.resort then 
        if self.count == 0 then 
            Updater:UnSubscribe(self) 
            self.Timers = nil
            collectgarbage()
            self.Timers = {}
            return
        end
        self.ResortList() 
    end
end
-- Add a timer
function SkillCounters:NewTimer(duration, message, unique, effect, loop, optionalIcon)
    --local count = tablelength(self.Timers)
    if unique then
        if self.UniqueTimers[message] then
            return
        else
            self.UniqueTimers[message] = true
        end
    end
    --[[
--]]
    --local optionalIcon = FireIcon
    --self.Timers[ID] =  {Counter(self, width, height, count, duration, message), duration, message}
    --self.Timers[#self.Timers + 1] = {Counter2(self, self.width, Settings.SNewTimer, self.count, duration, message, Settings.SNewFont, Turbine.UI.Color(1,0,0), Turbine.UI.Color(0.5,0,0), Turbine.UI.Color(0,0.125,0.5), Turbine.UI.Color(0,0.6,7), Turbine.UI.Color(0,0.0,0.8), nil, effect), duration, message, duration, loop}
    self.Timers[#self.Timers + 1] = {EffectTimer(self, self.width, self.TimerHeight, effect, message, self.font, self.colourScheme, true, nil, duration, optionalIcon), duration, message, duration, loop}
    
    --ID = ID + 1
    self.count = self.count + 1
    self.resort = true
    Updater:Subscribe(self)
    --PrintTable(self.Timers)
end

function SkillCounters:Clear()
    for key,v in spairs(self.Timers, function(t,a,b) return t[b][2] > t[a][2] end) do
        self.Timers[key][1]:Destroy()
        self.Timers[key] = nil
    end

    if Tablelength(self.Timers) > 0 then
        self:Clear()
    end
    self.Timers = nil
    collectgarbage()
    self.Timers = {}
end
